########################################################################################################
##						zLeaders					      ##
##												      ##
##	Created By:		Zebra 9								      ##
##	Created:		5 / 21 / 07							      ##
########################################################################################################

from CvPythonExtensions import *

# globals
gc = CyGlobalContext()

class zLeaders:
	def __init__(self):
		self.unitInfo = dict()
		self.buildingInfo = dict()
########################################################################################################
################			Add Your Code Below Here			################
########################################################################################################
		self.addUnitLeader("UNIT_WARRIOR", "LEADER_ALEXANDER")
		self.addBuildingLeader("BUILDING_BARRACKS", "LEADER_ALEXANDER")
########################################################################################################
################			Change Nothing Below Here			################
########################################################################################################

	def addUnitLeader(self, szUnit, szLeader):
		if not self.unitInfo.has_key(szUnit):
			self.unitInfo[szUnit] = list()
		self.unitInfo[szUnit].append(szLeader)

	def addBuildingLeader(self, szBuilding, szLeader):
		if not self.buildingInfo.has_key(szBuilding):
			self.buildingInfo[szBuilding] = list()
		self.buildingInfo[szBuilding].append(szLeader)

	def cannotTrainUnit(self, iPlayer, iUnit):
		unitType = gc.getUnitInfo(iUnit).getType()
		if self.unitInfo.has_key(unitType):
			leaderType = gc.getLeaderHeadInfo(gc.getPlayer(iPlayer).getLeaderType()).getType()
			if not (leaderType in self.unitInfo[unitType]):
				return True
		return False

	def cannotConstructBuilding(self, iPlayer, iBuilding):
		buildingType = gc.getBuildingInfo(iBuilding).getType()
		if self.buildingInfo.has_key(buildingType):
			leaderType = gc.getLeaderHeadInfo(gc.getPlayer(iPlayer).getLeaderType()).getType()
			if not (leaderType in self.buildingInfo[buildingType]):
				return True
		return False